// EQPacket.h

#ifndef __EQPacket_h__
#define __EQPacket_h__

#include "DatagramPacket.h"
#include "settings.h"
#include "EQServerSocketInterface.h"
/*
#define EQ_MSG_NON 0x0000
#define EQ_MSG_SYS 0x0001
#define EQ_MSG_ACK 0x0004
#define EQ_MSG_UNK 0x0010		// unknown, 1 byte after SEQ .. means one missed packet (the one thats after the ACK'ed in this packet .. so if its acked for 0x0001 .. the missng packet is 0x0002
#define EQ_MSG_SEQ 0x0200
#define EQ_MSG_CLS 0x0400		// server closing connection
#define EQ_MSG_FRG 0x0800
#define EQ_MSG_MSG 0x1000
#define EQ_MSG_SYN 0x2000
#define EQ_MSG_FIN 0x4400		// client finished
*/
class CEQPacket : public CDatagramPacket
{
private:
	unsigned short m_PacketID;
	unsigned short m_SequenceID;
	unsigned short m_AcknowledgeID;
	unsigned short m_FragID;
	unsigned short m_FragIndex;
	unsigned short m_MaxFragIndex;
	unsigned char  m_MessageID;

	bool m_Acknowledge;
	bool m_Finish;
	bool m_Fragmented;
	bool m_Message;
	bool m_MSG_UNK;
	bool m_Sequenced;
	bool m_Syncronize;
	bool m_System;

	unsigned char *m_pData;
	unsigned int m_Length;
	static CDatagramPacket m_acker;

public:
	CEQPacket(size_t szMaxPacketSize, size_t szInitialDataSize = 0)
		: CDatagramPacket(szMaxPacketSize, szInitialDataSize)
	{
		clearFlags();
	}
	
	CEQPacket(const CDatagramPacket &packet)
		: CDatagramPacket(packet)
	{
		clearFlags();
	}

	void clearFlags()
	{
		// memset( (void*)this + sizeof(CDatagramPacket),
		//			sizeof(CEQPacket) - sizeof(CDatagramPacket), 0);

		m_PacketID		= 0;
		m_SequenceID	= 0;
		m_AcknowledgeID	= 0;
		m_FragID		= 0;
		m_FragIndex		= 0;
		m_MaxFragIndex	= 0;
		m_MessageID		= 0;

		m_Acknowledge	= false;
		m_Finish		= false;
		m_Fragmented	= false;
		m_Message		= false;
		m_MSG_UNK		= false;
		m_Sequenced		= false;
		m_Syncronize	= false;
		m_System		= false;

		m_pData			= NULL;
		m_Length		= 0;
	}


	// returns false if the packet is invalid in any way.
	bool DisAssemblePacket();

	// create and return a packet to ACK this one. Should only be called
	// after this packet has been disassembled.
	CDatagramPacket *getACKPacket(unsigned short packetID);

//	void AddSendPacket(int myClientSocket, struct sQueuePacket &myPacket);
//	int AssemblePacket(int myClientSocket, sQueuePacket &xmyPacket/*TODO*/, unsigned char *pBuffer);

//private:
	static unsigned int GetDWord(const void *buf, int pos)	
	{
		unsigned char *pcBuf = (unsigned char*) buf;

		return	((unsigned int)(pcBuf[pos]) << 24) +
				((unsigned int)(pcBuf[pos + 1]) << 16) +
				((unsigned int)(pcBuf[pos + 2]) << 8) +
				(unsigned int)pcBuf[pos + 3];
	}

	static unsigned short GetWord(const void *buf, int pos)
	{
		unsigned char *pcBuf = (unsigned char*) buf;

		return	((unsigned short)(pcBuf[pos]) << 8) +
				(unsigned short)pcBuf[pos + 1];
	}

	static void FillDWord(void *buf, int pos, unsigned int value) 
	{ 
		unsigned char *pcBuf = (unsigned char*) buf;

		pcBuf[pos] = ((value >> 24) & 0xff);
		pcBuf[pos + 1] = ((value >> 16) & 0xff);
		pcBuf[pos + 2] = ((value >> 8) & 0xff);
		pcBuf[pos + 3] = (value & 0xff);
	}

	static void FillWord(void *buf, int pos, unsigned short value)
	{
		unsigned char *pcBuf = (unsigned char*) buf;

		pcBuf[pos] = ((value >> 8) & 0xff);
		pcBuf[pos + 1] = (value & 0xff);
	}

public:
	// Getters
	bool isAcknowledge(){ return m_Acknowledge; }
	bool isFinish()		{ return m_Finish; }
	bool isFragmented()	{ return m_Fragmented; }
	bool isMessage()	{ return m_Message; }
	bool isMSG_UNK()	{ return m_MSG_UNK; }
	bool isSequenced()	{ return m_Sequenced; }
	bool isSyncronize()	{ return m_Syncronize; }
	bool isSystem()		{ return m_System; }

	unsigned short getPacketID()	{ return m_PacketID; }
	unsigned short getSequenceID()	{ return m_SequenceID; }
	unsigned short getAcknowledgeID(){ return m_AcknowledgeID; }
	unsigned short getFragID()		{ return m_FragID; }
	unsigned short getFragIndex()	{ return m_FragIndex; }
	unsigned short getMaxFragIndex(){ return m_MaxFragIndex; }
	unsigned char  getMessageID()	{ return m_MessageID; }

	const char* getMsgData()		{ return (const char*)m_pData;}
	unsigned int getMsgDataLen()	{ return m_Length;}
};

#endif // __EQPacket_h__